test_gns_delegated_lookup.sh 1.6 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344
  1. #!/bin/sh
  2. # This file is in the public domain.
  3. trap "gnunet-arm -e -c test_gns_lookup.conf" INT
  4. which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 30"
  5. LOCATION=$(which gnunet-config)
  6. if [ -z $LOCATION ]
  7. then
  8. LOCATION="gnunet-config"
  9. fi
  10. $LOCATION --version 1> /dev/null
  11. if test $? != 0
  12. then
  13. echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
  14. exit 77
  15. fi
  16. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  17. MY_EGO="myego"
  18. OTHER_EGO="delegatedego"
  19. FINAL_LABEL="www"
  20. DELEGATION_LABEL="b"
  21. TEST_IP="127.0.0.1"
  22. gnunet-arm -s -c test_gns_lookup.conf
  23. gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
  24. DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
  25. gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
  26. gnunet-namestore -p -z $MY_EGO -a -n $DELEGATION_LABEL -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  27. gnunet-namestore -p -z $OTHER_EGO -a -n $FINAL_LABEL -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  28. RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u $FINAL_LABEL.$DELEGATION_LABEL.$MY_EGO -t A -c test_gns_lookup.conf`
  29. gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  30. gnunet-namestore -z $OTHER_EGO -d -n $FINAL_LABEL -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  31. gnunet-arm -e -c test_gns_lookup.conf
  32. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  33. if [ "$RES_IP" = "$TEST_IP" ]
  34. then
  35. exit 0
  36. else
  37. echo "Failed to resolve to proper IP, got $RES_IP."
  38. exit 1
  39. fi